<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
<!-- bootstrap -->
<link href="//cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
<! -- fontawesome (document est static donc ref /static) -->
<link href="fontawesome/css/fontawesome.min.css?version=5.14.0" rel="stylesheet">
<link href="fontawesome/css/brands.min.css?version=5.14.0" rel="stylesheet">
<link href="fontawesome/css/solid.min.css?version=5.14.0" rel="stylesheet">
  <title>Documentation sur les outils de validation</title>
  <style type="text/css">
      code{white-space: pre-wrap; background-color:lightyellow; padding: .2em .4em;display:block;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
      nav#TOC{float: right; margin: 1em; border: 1px solid gray; background-color: #f0f998; }
      h1.title{text-align:center; background-color: lightblue; }
  </style>
</head>
<body>
<p style="color:blue">
<div style="float:left;">
<img src="images/LogoUCB.png" alt="Lyon 1" width="100">
&emsp;
<a href="https://fst-meca.univ-lyon1.fr">Département Mécanique
&emsp;
<i class="fas fa-university"></i>
</a></div>
<div style="float:right;">
<a href="..">
Home &emsp;
<i class="fas fa-sign-in-alt"></i>
&emsp;
</a></div>
<div style="clear: both;"></div>
</p>
<header id="title-block-header">
<h1 class="title">Documentation sur les outils de validation</h1>
</header>
<nav id="TOC">
<ul>
<li><a href="#développement">Développement</a></li>
<li><a href="#principe">Principe</a><ul>
<li><a href="#notebook">notebook</a></li>
</ul></li>
<li><a href="#configuration">Configuration</a><ul>
<li><a href="#définition">définition</a></li>
<li><a href="#structure-dun-cours">structure d’un cours</a></li>
<li><a href="#fichiers-de-configuration">fichiers de configuration</a></li>
<li><a href="#fichier-tpxx.cfg">fichier TPxx.cfg</a></li>
</ul></li>
<li><a href="#interface-web">Interface Web</a><ul>
<li><a href="#home">Home</a></li>
<li><a href="#cours">Cours</a></li>
<li><a href="#tp">TP</a></li>
<li><a href="#doc">Doc</a></li>
<li><a href="#about">About</a></li>
</ul></li>
</ul>
</nav>
<h1 id="développement">Développement</h1>
<p>Cette application a été développée sous <a href="https://linux.org/">Linux <i class="fab fa-linux"></i></a> avec <a href="https://python.org">Python <i class="fab fa-python" aria_hidden="true"></i></a> et <a href="https://flask.palletsprojects.com/">Flask <i class="fas fa-flask"></i></a> par <a href="https://perso.univ-lyon1.fr/marc.buffat/">Marc BUFFAT (département mécanique, UCB Lyon 1)</a> au départ pour des besoins pédagogiques personnels.</p>
<p>Elle utilise le principe de base d’Unix <strong>Keep It Simple, Stupid!</strong></p>
<p>Elle consiste en un ensemble de scripts shell ou de programmes Python, utilisés en ligne de commande pour analyser, évaluer et noter les TP des étudiants, avec une interface Web développée avec le framework Flask en python, avec des liens avec Jupyterhub et nbgrader.</p>
<h1 id="principe">Principe</h1>
<p>Chaque cours est constitué de plusieurs TP, qui sont des documents (notebook, fichiers, data,..) que l’on échange avec les étudiants.</p>
<p>La validation opère sur chaque TP indépendamment avec les documents fournit par les étudiants. Le travail demandé étant personnel, on a un système de détection de plagiat entre étudiants. Le principe de la validation dépend de ce que l’on demande aux étudiants et des documents qui sont fournit par les étudiants. Le principe de base est de ne pas transférer les fichiers, et de faire la partie d’évaluation en ligne avec un simple navigateur et l’accès à une interface web. Le résultat peut ensuite être éventuellement récupéré, soit sous la forme d’un fichier standard (pdf), soit comme un fichier de notes au format standard csv (compatible <a href="https://tomuss.univ-lyon1.fr/"><strong>tomuss</strong></a>, soit copier directement sous <strong>tomuss</strong> avec la fonction <em>importer des valeurs</em> avec un copier-coller.</p>
<p>On génère un fichier de bilan par TP qui permet à l’enseignant d’accéder simplement à tous les résultats de l’étudiant sous forme standard html sans avoir à convertir les fichiers, ni exécuter les notebooks. En utilisant en partie l’évaluation automatique avec nbgrader, on peut compléter cette évaluation par l’analyse des commentaires des étudiants dans les notebooks ou des fichiers de comptes rendus au format pdf.</p>
<p>Pour tester le plagiat, les documents (notebook, fichier python, fichier tex pour les comptes rendus) sont tout d’abord convertit en fichier texte en ne conservant que les réponses des étudiants puis comparer entre eux à l’aide d’une métrique de levenshtein avec ou sans filtrage de mots clés. Le résultat est une table de similitude avec des valeurs de 0 a 1 dont on extrait la plus grande valeur sur chaque ligne. Si cette valeur est plus grande qu’une valeur type (de l’ordre de 0.8), alors on considère qu’un potentiel plagiat a pu avoir lieu entre les 2 étudiants, et l’enseignant peut alors comparer les 2 copies. Pour les notebooks, on extrait uniquement les réponses des étudiants dans certaines cellules.</p>
<h2 id="notebook">notebook</h2>
<p>L’étudiant doit compléter un notebook à trou fournit par l’enseignant. C’est l’utilisation la plus simple: l’enseignant crée son notebook avec des cellules vides et demande aux étudiants de répondre. A la fin l’enseignant aura alors la charge de l’évaluation complète du travail, comme un compte rendu de TP classique.</p>
<p>En utilisant le système <strong>nbgrader</strong> ( voir la documentation <a href="https://nbgrader.readthedocs.io/en/stable/"><strong>nbgrader</strong></a> ), l’enseignant peut modifier les attributs de chaque cellule du notebook en sélectionnant le menu:</p>
<ul>
<li>Affichage -&gt; Barre d’outil de cellule -&gt; Create Assignement</li>
</ul>
<p>Une barre d’outil apparaît alors en haut de chaque cellule avec un numéro de cellule ID (générer automatiquement mais modifiable) et un type choisit à partit d’un menu:</p>
<dl>
<dt><strong>-</strong></dt>
<dd>type par défaut
</dd>
<dt><strong>Manually graded answer</strong></dt>
<dd>permet de déclarer la cellule comme contenant une réponse de l’étudiant devant être évaluer manuellement. Dans ce cas peut lui attribuer des points
</dd>
<dt><strong>Manually graded task</strong></dt>
<dd>identique mais pour une tâche (voir la documentation)
</dd>
<dt><strong>Read-only</strong></dt>
<dd>la cellule n’est pas modifiable par l’étudiant. Typiquement elle contient les instructions ou du code fournit par l’enseignant.
</dd>
</dl>
<p>Si de plus la cellule est une cellule de code, alors on a en plus les 2 choix suivants:</p>
<dl>
<dt><strong>Autograded answer</strong></dt>
<dd>l’étudiant doit entrer du code python dans la cellule qui sera ensuite tester automatiquement dans la cellule suivante. L’enseignant peut entrer une solution entre les 2 balises <strong>### BEGIN SOLUTION</strong> et <strong>### END SOLUTION</strong>, qui ne sera pas vu par l’étudiant mais qui permet à l’enseignant de tester le notebook en articulier les tests des cellules <strong>autograder test</strong>
</dd>
<dt><strong>Autograder tets</strong></dt>
<dd>dans cette cellule l’enseignant test le résultat de l’étudiant en utilisant la fonction python <strong>assert()</strong> . Si l’étudiant passe les tests avec succès il a le nombre de points choisit dans la barre de menu.
</dd>
</dl>
<h1 id="configuration">Configuration</h1>
<dl>
<dt><strong>convention</strong></dt>
<dd>on utilise les conventions Unix pour les noms et les répertoires (dossiers), sans utilisation d’espace ou d’accents dans le nom (on peut avantageusement remplacer l’espace par l’underscore ’_’).
</dd>
</dl>
<h2 id="définition">définition</h2>
<dl>
<dt><strong>cours</strong></dt>
<dd>Un cours est associé à un nom (par convention son code APOGEE) p.e. <strong>MGCtest</strong>
</dd>
<dt><strong>TP</strong></dt>
<dd>chaque cours est constitué de plusieurs TP, qui sont des documents (notebook, fichiers, data,..) que l’on échange avec les étudiants avec la commande fetch et la commande submit. Dans le menu Assignments la première ligne indique le nom du cours sélectionné et en dessous la liste des TP publiés (released). Un TP est associé à un nom de TP (avec la convention Unix) qui correspond au nom du répertoire contenant tous les documents.
</dd>
<dt><strong>fetch</strong></dt>
<dd>la commande fetch de l’interface jupyter nbgrader Assignemnts-&gt;Fetch permet aux étudiants de récupérer les documents d’un TP.
</dd>
<dt><strong>submit</strong></dt>
<dd>la commande submit de l’interface jupyter nbgrader Assignemnts-&gt;Submit permet aux étudiants de soumettre le résultat de leur travail sur un TP.
</dd>
<dt><strong>etudiant</strong></dt>
<dd>les étudiants sont identifiés par leur identifiant de connexion, i.e. leur numéro d’étudiant avec le premier chiffre remplacé par un p, p.e. <strong>p1801574</strong> pour un numéro d’étudiant <em>11801574</em>
</dd>
<dt><strong>enseignant</strong></dt>
<dd>un enseignant a un statut d’étudiant par défaut, ce qui lui permet de tester l’interface étudiant
</dd>
<dt><strong>administrateur</strong></dt>
<dd>pour pouvoir administrer/modifier/gérer un cours, il faut avoir un statut administrateur, qui permet d’avoir accès au service du cours avec l’interface jupyter nbgrader: Control Panel -&gt; Services. Plusieurs enseignants (équipe enseignante) peuvent accéder à l’administration d’un même cours avec tous les mêmes droits. C’est donc à l’équipe de gérer le partage des taches entre les enseignants.
</dd>
</dl>
<p>La suite de la documentation s’adresse aux enseignants ayant se rôle administrateur de cours.</p>
<h2 id="structure-dun-cours">structure d’un cours</h2>
<p>Un cours sous Jupyter nbgrader est associé à un répertoire sur le serveur. Le nom du cours est par convention son code APOGEE. Par exemple le répertoire du cours <strong>MGCtest</strong> a la structure suivante</p>
<ul>
<li>répertoire du cours <strong>MGCtest</strong></li>
</ul>
<p>
<span style="display:block;background:lightyellow;"> <b>MGCtest/</b><br> ├── <i>autograded</i><br> │   ├── p1801574<br> │   │   └── TP4_Meule<br> │   ├── p1811042<br> │   │   └── TP4_Meule<br> │   └── p2006068<br> │       └── TP4_Meule<br> ├── <i>release</i><br> │   ├── TP4_Meule<br> │   └── TP5_Bille<br> ├── <b>source</b><br> │   ├── TP4_Meule<br> │   └── TP5_Bille<br> ├── <i>submitted</i><br> │   ├── p1801574<br> │   │   └── TP4_Meule<br> │   ├── p1811042<br> │   │   ├── TP3_Toupie3D<br> │   │   ├── TP4_Meule<br> │   │   └── TP5_Bille<br> │   └── p2006068<br> │       ├── TP4_Meule<br> │       └── TP5_Bille<br> └── <b>validation</b><br> </span>
</p>
<p>Les répertoires en italique sont crées automatiquement par <strong>nbgrader</strong></p>
<dl>
<dt><em>release</em></dt>
<dd>contient les TP mis en ligne par l’enseignant responsable du cours ( menu Formgrader de l’interface jupyter nbgrader)
</dd>
<dt><em>submitted</em></dt>
<dd>contient les TP qui ont été soumis par les étudiants. Pour chaque étudiant on trouve les TP soumis par cet étudiant
</dd>
<dt><em>nbgrader</em></dt>
<dd>contient le résultat de l’évaluation des TP par le système nbgrader, avec la même structure par étudiant
</dd>
</dl>
<p>Les répertoires en gras sont générés par l’administrateur</p>
<ul>
<li><strong>source</strong> contient les TP que l’enseignant fournit aux étudiants (dans l’exemple TP4_Meule et TP5_Bille)</li>
<li><strong>validation</strong> contient les résultats de l’analyse avec les outils de validation pour chacun des TP</li>
</ul>
<h2 id="fichiers-de-configuration">fichiers de configuration</h2>
<p>
<span style="display:block;background:lightyellow;"> <b>MCCtest/</b><br> ├── autograded<br> ├── gradebook.db<br> ├── <b>header.ipynb</b><br> ├── <i>hub_config.py</i><br> ├── <i>nbgrader_config.py</i><br> ├── README.notes<br> ├── release<br> ├── source<br> ├── submitted<br> ├── <b>TP4_Meule.cfg</b><br> ├── <b>TP5_Bille.cfg</b><br> └── validation<br> </span>
</p>
<p>Le répertoire du cours contient des fichiers de configuration système en italique, que l’on ne modifie en générale pas</p>
<dl>
<dt><em>nbgrader_config.py</em>:</dt>
<dd>définit le nom du cours et l’entête des notebooks (par défaut <em>header.ipynb</em>)
</dd>
<dt><em>hub_config.py</em></dt>
<dd>définit le service du cours, avec la liste des enseignants administrateur du cours (on peut rajouter des noms)
</dd>
</dl>
<p>Les fichiers de configuration en gras sont définit par l’enseignant</p>
<dl>
<dt><strong>header.ipynb</strong></dt>
<dd>notebook ipython d’entête pour tous les notebooks du cours
</dd>
<dt><strong>TPxx.cfg</strong></dt>
<dd>fichier de configuration pour chacun des TP du cours que l’on veut soumettre au système de validation (TPxx vaut dans l’exemple TP4_Meule.cfg et TP5_Bille.cfg). Ce fichier n’est obligatoire que si l’on veut utiliser le système de validation. Pour une utilisation de nbgrader de base, ce fichier n’est pas nécessaire.
</dd>
</dl>
<h2 id="fichier-tpxx.cfg">fichier TPxx.cfg</h2>
<p>La structure d’un fichier de configuration pour le système de validation suit la convention standard de la bibliothèque Python ConfigParser. ConfigParser est une classe Python qui implémente un langage de configuration de base pour les programmes Python. Il fournit une structure similaire aux fichiers INI de Microsoft Windows.</p>
<p>Par exemple le contenu du fichier <strong>TP4_Meule.cfg</strong> est le suivant:</p>
<pre><code>[IPYNB]
nomipynb = TP_Meule.ipynb
cellids = cell_all
[PDF]
nompdf = 
[TEX]
nomtex =
[BIB]
nombib = 
exos = 
direxos = 
[PGE]
nompge =
[MALUS]
similaire = 7
taux = 0.85
[NOTE]
base = 0.0
bib  = 0.0
ipynb= 1.0</code></pre>
<p>Les différentes sections entre [] sont obligatoires, ainsi que tous les mots clés de configuration, mais leur valeur peut être vide.</p>
<dl>
<dt><strong>section [IPYNB]</strong></dt>
<dd>définit le nom du notebook ou des notebooks du TP (séparés par une virgule “,” sans espace) dans le mot clé <strong>nomipynb</strong>. Le mot clé <strong>cellids</strong> permet de définir les cellules du notebook qui seront soumis au système de plagiat. Les valeurs possibles sont <strong>cell-all</strong> pour toutes les cellules solutions, <strong>cell_code</strong> pour uniquement les cellules de code, <strong>cell_markdown</strong> pour uniquement les cellules de texte, ou une liste de numéro ID de cellules.
</dd>
<dt><strong>section [TEX]</strong></dt>
<dd>définit le nom optionnel du fichier source latex pour le compte rendu dans <strong>nomtex</strong>. L’enseignant fournir la canevas LaTex de base. Ce fichier sera soumis au test de similitude s’il existe.
</dd>
<dt><strong>section [PDF]</strong></dt>
<dd>définit le nom optionnel du fichier pdf dans <strong>nompdf</strong>, correspondant à la version pdf du rapport obtenu avec pdflatex pour lecture par l’enseignant.
</dd>
<dt><strong>section [BIB]</strong></dt>
<dd>définit le nom optionnel dans <strong>nombib</strong> du fichier de bibliothèque python que l’étudiant doit écrire. Ce fichier sera soumis au test de similitude s’il existe. Dans <strong>exos</strong> on peut spécifier un dictionnaire de la forme <strong>val1:prog1,val2:prog2,..</strong>, ou prog1 est le nom d’un programme que l’étudiant doit écrire dans sa bibliothèque et val1 est le nom du programme de validation associé définit dans la bibliothèque validation. Dans le cas où on donne des exercices à faire tirés aléatoirement dans une banque d’exercices, on spécifie alors le nom du répertoire de configuration des exercices dans <strong>direxos</strong>.
</dd>
<dt><strong>section [PGE]</strong></dt>
<dd>définit le nom optionnel dans <strong>nompge</strong> du ou des fichiers programmes python que l’étudiant doit rendre. Ce fichier sera soumis au test de similitude s’il existe.
</dd>
<dt><strong>section [MALUS]</strong></dt>
<dd>définit la pénalité de malus sur la note dans <strong>similaire</strong> en cas de similitude trop importante. Le taux de similitude limite (de l’ordre de 0.8) est donné dans <strong>taux</strong>
</dd>
<dt><strong>section [NOTE]</strong></dt>
<dd>permet de définir le calcul de la notation automatique avec la formule
</dd>
</dl>
<p><strong>note = base + bib x note_autograde_bibilotheque + ipynb x note_autograde_notebook - malus</strong></p>
<h1 id="interface-web">Interface Web</h1>
<p>A partir du serveur jupyter-nbgrader du cours, on se connecte à l’interface web du système de validation, pour avoir accès aux différents outils de validation et aux résultats. En haut de la page on a accès à un menu permettant de choisir les différentes étapes</p>
<p>Cette interface a été développée en python avec le framework Flask et execute les différents scripts bash ou python pour éffectuer ces différentes étapes.</p>
<figure>
<img src="images/validationUI.png" alt="Exemple d’interface de validation" /><figcaption><em>Exemple d’interface de validation</em></figcaption>
</figure>
<h2 id="home">Home</h2>
<p>on choisit tout d’abord le cours parmi les cours que l’on administre sur le serveur</p>
<h2 id="cours">Cours</h2>
<p>Pour le cours sélectionner, on a la liste des TP qui ont été configuré dans le cours. On peut visualiser et modifier les fichiers de configuration TPxxx.cfg et on a un accès directe au dossier de ces TP (sous jupyterhub), que l’on peut donc modifier aussi.</p>
<p>Enfin on a une liste des étudiants ayant soumis au moins un TP dans le cours, ou se trouvant sur la base de données du cours.</p>
<h2 id="tp">TP</h2>
<p>Cette page permet de visualiser/configurer/évaluer un TP du cours.</p>
<ul>
<li>accès en édition au fichier de configuration du TP</li>
<li>accès au répertoire du TP</li>
<li>accès en édition à la liste des étudiants qui seront évalués. Attention cette liste contient uniquement le nom de connexion de l’étudiant</li>
<li>accès au bilan d’évaluation du TP pour tous les étudiants au format html ou pdf avec des liens vers le travail individuel de chaque étudiant</li>
<li>accès au bilan des notes des étudiants, avec visualisation du fichier de notes, exportation vers tomuss ou édition du fichier brute csv</li>
<li>récupération du travail des étudiants avec nbgrader (sans autograde)</li>
<li>création/mise à jour de la liste des étudiants ayant souis leur travail</li>
<li>génération du bilan d’évaluation pour tous les étudiants. Attention cette partie peut être longue suivant le nombre d’étudiants (de quelques minutes à plusieurs dizaines de minutes). Il faut attendre le résultat sous peine d’interrompre l’analyse.</li>
</ul>
<h2 id="doc">Doc</h2>
<p>lien vers cette documentation créer avec <strong>pandoc</strong> en <strong>markdown</strong></p>
<h2 id="about">About</h2>
<p>information sur la configuration (en cas de problème)</p>
</body>
</html>
